Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 

1033 
1733 
3733 
3739 
3779 
8779 
8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

题意:

给你两个四位的素数a,b。
a可以改变某一位上的数字变成c,但只有当c也是四位的素数时才能进行这种改变。
请你计算a最少经过多少次上述变换才能变成b。

解题思路:

先素数打表,筛选出1000 - 10000以内的素数,然后从x开始,遍历千 百 十 个的每一位,尝试所有可能的变换路径,每次改变其中一位,如果可以,就放入队列,并记录到新产生的数的次数加一

#pragma GCC optimize("O3")
#pragma G++ optimize("O3")

// #include <bits/stdc++.h>
#include <cstdio>
#include <queue>
#include <cstring>
#include <algorithm>

using namespace std;
const int N = 10010;

int prime[N];
int used[N];
int step[N];
void init()
{
    prime[0] = prime[1] = 1;
    for(int i=0; i<N/2; i++)
    {
        if(!prime[i])
        {
            for(int j = i+i; j < N; j += i)
                prime[j] = 1;
        }
    }
}

queue<int> que;
int bfs(int x, int y)
{
    memset(used, 0, sizeof(used));
    memset(step, 0, sizeof(step));
    while( !que.empty())    que.pop();
    
    que.push(x);
    used[x] = 1;
    step[x] = 0;
    while( !que.empty())
    {
        int now = que.front();  que.pop();
        if(now == y)    return step[now];

        int next = now % 1000;      // 去掉千位
        for(int i=1000; i < 10000; i += 1000)   // 遍历千位,千位至少从1开始
        {
            if(prime[next + i] == 0 && !used[next + i])
            {
                used[next + i] = 1;
                que.push(next + i);
                step[next + i] = step[now] + 1;
            }
        }
        
        int tho = now / 1000 * 1000;;
        next = now % 100;
        for(int i=0; i < 1000; i += 100)
        {
            if(prime[tho + i + next] == 0 && !used[tho + i + next])
            {
                used[tho + i + next] = 1;
                que.push(tho + i + next);
                step[tho + i + next] = step[now] + 1;
            }
        }

        int hun = (now % 1000) / 100 * 100;
        next = now % 10;
        for(int i=0; i < 100; i += 10)
        {
            if(prime[tho + hun + i + next] == 0 && !used[tho + hun + i + next])
            {
                used[tho + hun + i + next] = 1;
                que.push(tho + hun + i + next);
                step[tho + hun + i + next] = step[now] + 1;
            }
        }

        next = now / 10;
        for(int i=0; i<10; i++)
        {
            if(prime[next*10 + i] == 0 && !used[next * 10 + i])
            {
                used[next * 10 + i] = 1;
                que.push(next * 10 + i);
                step[next * 10 + i] = step[now] + 1;
            }
        }
    }
    return -1;
}

int main()
{
    init();
    int t;
    scanf("%d", &t);
    while(t--)
    {
        int a, b;
        scanf("%d %d", &a, &b);
        int ans = bfs(a, b);
        if(ans == -1)
            printf("Impossible\n");
        else
            printf("%d\n", ans);
    }


    return 0;
}